package model

import (
	"time"

	"gorm.io/gorm"
)

type QuestionnaireSubject struct {
	ID        int64          `gorm:"type:int(20);primaryKey;autoIncrement;comment:ID;" json:"id"`
	SN        string         `gorm:"type:varchar(255);not null;comment:编号" json:"sn"`
	Type      int            `gorm:"type:int(11);comment:类型;default:1;" json:"type"`
	Title     string         `gorm:"type:varchar(255);not null;comment:标题" json:"title"`
	Validator string         `gorm:"type:longText;nullable;comment:校验器" json:"validator"`
	Remark    string         `gorm:"type:varchar(255);default:'';comment:备注" json:"remark"`
	Mark      string         `gorm:"type:varchar(255);default:'';comment:标记" json:"mark"`
	DeletedAt gorm.DeletedAt `gorm:"column:deleted_at" json:"-"`
	CreatedAt time.Time      `gorm:"column:created_at" json:"createdAt"`
	UpdatedAt time.Time      `gorm:"column:updated_at" json:"updatedAt"`
}

func (s *QuestionnaireSubject) AfterFind(tx *gorm.DB) (err error) {
	return
}
