package model

import (
	"time"

	"gorm.io/gorm"
)

const (
	SystemSettingTableName = "system_setting" // 表名
)

const (
	SystemSettingKeyAlgorAppKey    = "AlgorAppKey"
	SystemSettingKeyAlgorAppSecret = "AlgorAppSecret"
	SystemSettingKeyAlgorDomain    = "AlgorDomain"
	SystemSettingKeyAlgorDefaultSn = "AlgorDefaultSn"
)

type SystemSetting struct {
	ID        int64          `gorm:"type:int(20);autoIncrement;comment:ID;" json:"id"`
	Key       string         `gorm:"type:varchar(255);comment:KEY;" json:"key"`
	Value     string         `gorm:"type:varchar(255);comment:VALUE;" json:"value"`
	DeletedAt gorm.DeletedAt `gorm:"column:deleted_at" json:"-"`
	CreatedAt time.Time      `gorm:"column:created_at" json:"createdAt"`
	UpdatedAt time.Time      `gorm:"column:updated_at" json:"updatedAt"`
}

func (u *SystemSetting) AfterCreate(tx *gorm.DB) (err error) {
	// tx.Model(u).Update("sn", util.GetHashId(u.ID, MechanismTableName))
	return
}

func (u *SystemSetting) AfterFind(tx *gorm.DB) (err error) {
	return
}

func (u *SystemSetting) TableName() string {
	dbPrefix := ""
	return dbPrefix + SystemSettingTableName
}
